<?php

/* --------------------------------------------------------------------

Author: 松鼠大大
Author URL: https://doge.uk/
Version: 1.0
Thanks: https://github.com/denpamusic/chevereto-yandex-oauth
@Chevereto: 3.13.3
@requires route.install-github.php

  --------------------------------------------------------------------- */

$route = function($handler) {
	// Must be an admin
	if(!CHV\Login::getUser()['is_admin']) {
		G\redirect();
	}
	/* Get table prefix */
	$table_prefix = G\get_app_setting('db_table_prefix');
	$fields = G\DB::queryFetchAll("DESCRIBE ${table_prefix}logins");
	foreach($fields as $v) {
		if($v['Field'] == 'login_type') {
			$login_type = $v['Type'];
			continue;
		}
	}
	$login_type = explode(',', trim(str_replace('enum(', '(', $login_type), '()'));
	if( !in_array("'github'", $login_type) ) {
		$login_type[] = "'github'";
	}
	$login_type = implode(',', $login_type);
	$sql_update = [
		/* Settings values */
		'github' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'github', 0, 0, 'bool');",
		'github_client_id' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'github_client_id', NULL, NULL, 'string');",
		'github_client_secret' => "INSERT INTO `${table_prefix}settings`(`setting_id`, `setting_name`, `setting_value`, `setting_default`, `setting_typeset`) VALUES (NULL, 'github_client_secret', NULL, NULL, 'string');",
		/* Support new social login type */
		"ALTER TABLE `${table_prefix}logins` CHANGE `login_type` `login_type` ENUM($login_type) CHARACTER SET utf8mb4 COLLATE utf8mb4_unicode_ci NOT NULL;",
	];
	$settings = G\DB::queryFetchAll("SELECT `setting_name` FROM `${table_prefix}settings`");
	// Remove existing settings
	foreach($settings as $v) {
		if( isset($sql_update[$v['setting_name']]) ) {
			unset($sql_update[$v['setting_name']]);
		}
	}
	$sql_update = join("\r\n", $sql_update);
	try {
		$db = G\DB::getInstance();
		$db->query($sql_update);
		$updated = $db->exec();
		if($updated) {
			echo '数据库升级完成！<br>为安全起见，在运行完成后删除此升级文件！！！';
		}
		exit();
	} catch(Exception $e) {
		G\exception_to_error($e);
	}
};